 
/*
 * Copyright (c) 1990, William C. Ogden, ogden@nmsu.edu
 *
 * Permission is granted to copy and distribute this file in modified
 * or unmodified form, for noncommercial use, provided (a) this copyright
 * notice is preserved, (b) no attempt is made to restrict redistribution
 * of this file, and (c) this file is not distributed as part of any
 * collection whose redistribution is restricted by a compilation copyright.
 */

#include <stdio.h>
#include <math.h>
/*#ifdef SUNOS4_1 */
#include <stdlib.h>
/*#endif /* SUNOS4_1 */
#include <sys/file.h>
#include <sys/param.h>
#include <sys/types.h>
#include <unistd.h>
#include <xview/xview.h>
#include <xview/panel.h>
#include <xview/textsw.h>
#include <xview/xv_xrect.h>
/*#include <gdd.h>*/
#include <xview/notice.h>
#include "bt_ui.h"

#include "bt.h"
#include <ctype.h>



int  annote_edit_count, ns_edit_count;
int 	MERGE_FLAG,PASTE_FLAG;
SLIST select_list;
FILE           *infile;

Panel_item field_ptr[26], nxt_fld[26], expand_item;


char *months[] = {	"",
			  "#jan",
			  "#feb",
			  "#mar",
			  "#apr",
			  "#may",
			  "#jun",
			  "#jul",
			  "#aug",
			  "#sep",
			  "#oct",
			  "#nov",
			  "#dec"
			};

char *rtypes[] = {	"article",
			  "book",
			  "booklet",
			  "inproceedings",
			  "inbook",
			  "incollection",
			  "manual",
			  "mastersthesis",
			  "phdthesis",
			  "proceedings",
			  "techreport",
			  "unpublished",
			  "misc"
			};


char           *fields[] = {
	"citekey"
	,"author"
	,"address"
	,"booktitle"
	,"chapter"
	,"crossref"
	,"edition"
	,"editor"
	,"howpublished"
	,"institution"
	,"journal"
	,"key"
	,"month"
	,"note"
	,"number"
	,"organization"
	,"pages"
	,"publisher"
	,"school"
	,"series"
	,"title"
	,"type"
	,"volume"
	,"year"
};
void init_field_ptr()
{ 	int	i;

    field_ptr[0] = bt_window1->citekey;
    field_ptr[1] = bt_window1->author;
    field_ptr[2] = bt_window1->address;
    field_ptr[3] = bt_window1->booktitle;
    field_ptr[4] = bt_window1->chapter;
    field_ptr[5] = bt_window1->crossref;
    field_ptr[6] = bt_window1->edition;
    field_ptr[7] = bt_window1->editor;
    field_ptr[8] = bt_window1->howpublished;
    field_ptr[9] = bt_window1->institution;
    field_ptr[10] = bt_window1->journal;
    field_ptr[11] = bt_window1->key;
    field_ptr[12] = bt_window1->month;
    field_ptr[13] = bt_window1->note;
    field_ptr[14] = bt_window1->number;
    field_ptr[15] = bt_window1->organization;
    field_ptr[16] = bt_window1->pages;
    field_ptr[17] = bt_window1->publisher;
    field_ptr[18] = bt_window1->school;
    field_ptr[19] = bt_window1->series;
    field_ptr[20] = bt_window1->title;
    field_ptr[21] = bt_window1->type;
    field_ptr[22] = bt_window1->volume;
    field_ptr[23] = bt_window1->year;
    
	for (i = 0 ; i < 24; i++)
		xv_set(field_ptr[i],PANEL_NOTIFY_LEVEL,PANEL_NON_PRINTABLE,NULL);
		    
    nxt_fld[0] = bt_window1->citekey;
    nxt_fld[1] = bt_window1->key;
    
    xv_set(bt_clip_pop->clip_text,
	   TEXTSW_IGNORE_LIMIT, TEXTSW_INFINITY,
	   0 );
    xv_set(bt_annotepop->annote_text,
	   TEXTSW_IGNORE_LIMIT, TEXTSW_INFINITY,
	   0 );
    xv_set(bt_nspop->ns_text,
	   TEXTSW_IGNORE_LIMIT, TEXTSW_INFINITY,
	   0 );
    xv_set(bt_expand->ex_text,
	   TEXTSW_IGNORE_LIMIT, TEXTSW_INFINITY,
	   0 );
 /*    malloc_debug(2);  */
    sort_flag = 0;
    
}



/* search a PATH for a FILE which can be sent to fopen with MODE. 
   PATH should be a colon separated path variable in the style of unix
   shells, file should be a file name (or path name segment) and MODE
   should be in the style of fopen, except that "x" can also be
   included to see if a file can be executed.  exec already handles
   path search, but this might well be handy for dynamic loading or
   some such.

   the full path name of the first file that satisfies the mode
   criterion is returned in a newly cons'ed area that the caller must
   deallocate. */


char           *
find_in_path(path, name, mode)
	char            path[], name[], mode[];
{
	char           *file_name;
	char           *p, *q;
	int             md;

	md = 0;
	p = mode;
	while ((*p)!='\0') {
		switch (*p) {
		case 'r':
			md |= R_OK;
			break;
		case 'w':
		case 'a':
		case '+':
			md |= W_OK;
			break;
		case 'x':
			md |= X_OK;
		}
		p++;
	}

	file_name = malloc(strlen(path) + strlen(path) + 2);

	p = path;
	while (p) {
		strcpy(file_name, p);
		q = index(file_name, ':') ;
		if (q == NULL) {
			q = file_name + strlen(file_name);
		}
		sprintf(q, "/%s", name);	/* double slash is ok on unix */
		if (access(file_name, md) == 0) {
			return file_name;
		}
		p = index(p, ':');
		if (p)
		 p++;
	}

	free(file_name);
	return NULL;
}


#define TOLOWER(c) (isupper(c)?tolower(c):(c))
 
int
strcasecmp(s1,s2)
     char *s1, *s2;
{
   char *t1, *t2;
  t1=s1;
  t2=s2;
  
  while((*t1)!='\0' && TOLOWER(*t1)==TOLOWER(*t2))
    {
      t1++;
      t2++;
    }
  
  if (*t1 == '\0' && *t2 == '\0')
    return(0);
  else 
    return(TOLOWER(*t1) - TOLOWER(*t2));
}

int
  strncasecmp( s1, s2, len)

char *s1, *s2;
int len;

{
    int tmp;
    int n=1;
    
    while ( n <= len ) {
	if (( tmp = ( isupper( *s1) ? tolower( *s1) : *s1) - 
	     ( isupper( *s2) ? tolower( *s2) : *s2)) != 0)
	  return( tmp);
	s1++; s2++; n++;
    }
    return(0);
}

/* strstr - find first occurrence of wanted in s
   Copyright (C) 1989, Free Software Foundation.
   
   */   


#define CONST
#define SIZET int

#define	NULL	0

char *				/* found string, or NULL if none */
  strstr(s, wanted)
CONST char *s;
CONST char *wanted;
{
    register CONST char *scan;
    register SIZET len;
    register char firstc;
    extern int strcmp();
    extern SIZET strlen();
    
    /*
     * The odd placement of the two tests is so "" is findable.
     * Also, we inline the first char for speed.
     * The ++ on scan has been moved down for optimization.
     */
    firstc = *wanted;
    len = strlen(wanted);
    for (scan = s; *scan != firstc || strncmp(scan, wanted, len) != 0; )	
      if (*scan++ == '\0')
	return(NULL);
    return(scan);
}


char *				/*A case insensitive version */
  strcasestr(s, wanted)
CONST char *s;
CONST char *wanted;
{
    register CONST char *scan;
    register SIZET len;
    register char firstc;
    extern int strcmp();
    extern SIZET strlen();
    
    firstc =  ( isupper( *wanted) ? tolower( *wanted) : *wanted);
    len = strlen(wanted);
    for (scan = s; strncasecmp(scan, wanted, len) != 0; ) {
	
	if (*scan++ == '\0')
	  return(NULL);
    }
    return(scan);
}


void toLower(s1)
     
     char * s1;
     
{
    char * aux = s1;
    
    
    while (*aux) {
      *aux = isupper(*aux) ? tolower(*aux) : *aux;
      *aux++;
    }
}


int
isNumber(s1)
	char           *s1;

{
	char           *aux = s1;


	while (*aux) {
		if (isgraph(*aux))
			if (!isdigit(*aux))
				return (0);
		*aux++;
	}
	return (1);

}

void
get_total()
{
	Ref 	ref;
	
	total = 0;
	ref = first_item;
	while (ref){
		total++;
		ref = ref->next;
	}
}
	
double nlogn(n)
int n;
{
    return (double) (n) * (log((double) n));
}

void
update_progress()
{
	double          value = sort_count / (nlogn(total));
	int				val;
	
	val = (int) (value * (double) 100);
	if (oldval != val) {
		xv_set(bt_sortpop->progress,
		       PANEL_PAINT, PANEL_NO_CLEAR,
		       PANEL_VALUE, val, 0);
		XFlush((Display *) xv_get(bt_sortpop->sortpop,XV_DISPLAY));
		oldval = val;
	}

}

#define STRCMP(a,b) ((a)==(b))?0:(((a)==NULL)?-1:(((b)==NULL)?1:strcasecmp(a,b)))

Ref
merge_Refs(a, b)
	Ref             a, b;
{
	int             field = (int) xv_get(bt_sortpop->sort_field_setting, PANEL_VALUE);
	int             direction = (int) xv_get(bt_sortpop->sort_direction, PANEL_VALUE);
	Ref             r, p;

	if (!a) {
		return b;
	}
	if (!b) {
		return a;
	}
	if (direction ? STRCMP(a->field[field], b->field[field]) >= 0 :
	    STRCMP(a->field[field], b->field[field]) <= 0) {
		r = p = a;
		a = a->next;
		p->next = NULL;
	} else {
		r = p = b;
		b = b->next;
		p->next = NULL;
	}

	while (a && b) {
		sort_count++;
		update_progress();
		if (direction ? STRCMP(a->field[field], b->field[field]) >= 0 :
		    STRCMP(a->field[field], b->field[field]) <= 0) {
			p->next = a;
			a = a->next;
			p = p->next;
			p->next = NULL;
		} else {
			p->next = b;
			b = b->next;
			p = p->next;
			p->next = NULL;
		}
	}

	if (!a) {
		p->next = b;
	}
	if (!b) {
		p->next = a;
	}
	return r;
}

Ref 
merge_sort(a)
	Ref             a;
{
	if (!a || !a->next){
		return a;
		}
	else {
		Ref             p1, p2;

		p1 = a;
		p2 = a->next;
		while (p2 && p2->next) {
	 		sort_count++;
			update_progress();
			p1 = p1->next;
			p2 = p2->next->next;
		}

		p2 = p1->next;
		p1->next = NULL;
		return merge_Refs(merge_sort(a), merge_sort(p2));
	}
}

void
  set_find_fields()

{
    int i,argc;
    char      **avlist;
    
    argc=24;
    
    avlist = (char **) malloc((argc + 6) * sizeof (char *));
    
    avlist[0] = (char *) PANEL_CHOICE_STRINGS;
    for (i = 0; i < argc; i++){
      if ( i == 12)
        avlist[i+1] = (char *) "Month:";
      else
        avlist[i+1] = (char *)  
	  xv_get(field_ptr[i],PANEL_LABEL_STRING);
    }
    avlist[++i] = (char *) "Annotation:";
    avlist[++i] = (char *) "All fields";
 
    avlist[++i] = (char *) NULL;   /* NULL-terminate strings */
    avlist[++i] = (char *) NULL;   /* NULL-terminate avlist */
    
    /*
     * Set the scrolling list and free the avlist.
     */
    xv_set(bt_findpop->setting1, ATTR_LIST, avlist, NULL);
    avlist[i-2] = (char *) NULL;  /* remove annote field for sorting list */
    xv_set(bt_sortpop->sort_field_setting, ATTR_LIST, avlist, NULL);
   
    free((char *) avlist);
    xv_set(bt_sortpop->progress,PANEL_PAINT,PANEL_NO_CLEAR,0);
    

}

int
  duplicate_cite_key(key)
char * key;
{
    Ref ref;
    
    ref = first_item;
    while (ref != NULL) {
	if (ref->field[0])
	if (strcasecmp(key,ref->field[0]) == 0)
	  return(1);
	ref = ref->next;
    }
    return(0);
}
int
  standard(field)
char * field;
{
    int	i = 1;
    
    while (i < 24)  
      if (strcmp(field,fields[i++]) == 0)
	return(1);
    
    return(0);
}

void
	clear_all_selections()
{
	int             i;
	int             nItems = (int) xv_get(bt_listpop->list, PANEL_LIST_NROWS);

	for (i = 0; i < nItems; i++) 
		 xv_set(bt_listpop->list, PANEL_LIST_SELECT, i, FALSE, PANEL_PAINT,PANEL_NONE,0);

}	

void
  find()
{
    extern void show_current_item();
    Ref ref,first_found;
    char findstr[80],  *findfield;
    int field = (int) xv_get(bt_findpop->setting1,PANEL_VALUE,NULL);
    int i,index,first,n, case_flag;
    
    strcpy(findstr , ( char * ) xv_get(bt_findpop->findstr, PANEL_VALUE));
    case_flag = (int) xv_get(bt_findpop->case_set, PANEL_VALUE);

    ref = first_item;
    index = 0;
    first = -1;
    while (ref != current_item) {
		ref = ref->next;
		index++;
     }
    if (strlen(findstr) > 0) {
	clear_all_selections();
	do {
	    ref = ref->next;
	    index++;
	    if (ref == NULL){
		index = 0;
		ref = first_item;
	    }
	    if (field == 25) { /* all fields */
		set_str(findfield,ref->annote);
		add_to(findfield,ref->nsfield);
		for ( i = 0; i < 24; i++) 
		  add_to(findfield,ref->field[i]);
	    }
            else if (field == 24){
		set_str(findfield,ref->annote);
	    } else{
		set_str(findfield,ref->field[field]);
	    }
	    if (findfield)
	      if (strlen(findfield) > 0) {
	      
		if ( case_flag ? strcasestr(findfield,findstr) != 0 :
		    strstr(findfield,findstr)  != 0) { 

		    if (first == -1) {
			first = index;
			first_found=ref;
		    }
		    xv_set(bt_listpop->list,PANEL_LIST_SELECT,index,TRUE, PANEL_PAINT,PANEL_NONE,NULL);
			}
	      }
	    
	}
	while (ref != current_item);
    }
    if (first != -1) {
	current_item = first_found;
	show_current_item();
    }
    else {
	
	notice_prompt(bt_window1->controls1, NULL,
		      NOTICE_MESSAGE_STRINGS,
		      "Not Found",NULL,
		      NOTICE_BUTTON_YES, "Continue",
		      NULL);
    }
    
}

/*
 * void ReassignListEntries(Panel_item list, char **entries)
 *
 *     Replaces all of the entries in 'list' with the strings in the
 *     null-terminated array 'entries'.
 *      + only replaces entries if they are different
 *      + buffers replacements for efficiency
 *      + manipulates the scrollbar correctly
 *      + deactivates the list if it is empty
 *      + works around several XView bugs
 *
 * Copyright (c) 1990 Elan Computer Group, Inc.
 * All Rights Reserved.
 *
 * This is published non-proprietary source code of Elan Computer Group, Inc.
 * Any and all parties are free to distribute this code or include it in
 * any product or program, whether for sale or free distribution.
 * This source code is not under any warranty or guarantee, explicitly
 * or implicitly, by Elan Computer Group Inc. or its employees.
 */
/*
#include <xview/xview.h>
#include <xview/panel.h>
*/
#include <xview/scrollbar.h>

typedef unsigned char Boolean;
#if ! defined(TRUE)
#define TRUE	(1)
#define FALSE	(0)
#endif

/* limit for ATTR_LIST including a pad */
#define MAX_XVIEW_ATTRIBUTES    (255 - 20)

extern char *malloc();
extern int free();
extern int strcmp();

void
ReassignListEntries(list, entries)
Panel_item list;
char **entries;
{
    register int newNumItems, currentNumItems, attrIndex, entryIndex;
    int attrListSize;
    Xv_opaque *attrList;
    Boolean listInactive, scrollbarInactive;
    
    
    currentNumItems = (int) xv_get(list, PANEL_LIST_NROWS);
    if ((entries == (char **) 0) || (entries[0] == (char *) 0)) {
	newNumItems = 0;
	listInactive = TRUE;
    } else {
	for (newNumItems = 0; entries[newNumItems] != 0; newNumItems++) ;
	listInactive = FALSE;
    }

    /* see if the lists are the same */
    if (currentNumItems == newNumItems) {
	register int i;
	register char *itemStr;
	Boolean same = TRUE;

	for (i = 0; i < newNumItems; i++) {
	    itemStr = (char *) xv_get(list, PANEL_LIST_STRING, i);
	    if (strcmp(itemStr, entries[i]) != 0) {
		same = FALSE;
		break;
	    }
	}
	
	
	if (same) {
	    return;
	}
    }

    if (newNumItems == 0) {
	/* must have at least one entry to hold selection (XView bug) */
	newNumItems = 1;
    }


    /* for each element: ATTR + index + string */
    attrListSize = newNumItems * 3;
    if (currentNumItems > newNumItems) {
	/* ATTR + indexx for each extra element */
	attrListSize += (currentNumItems - newNumItems) * 2;
    }
    /* null terminator for ATTR_LIST */
    attrListSize++;
    
    attrList = (Xv_opaque *)
		malloc((unsigned) (attrListSize * sizeof(Xv_opaque)));
    attrIndex = 0;
    /* delete excess entries */
    while (currentNumItems > newNumItems) {
	attrList[attrIndex] = (Xv_opaque) PANEL_LIST_DELETE;
	attrList[attrIndex + 1] = (Xv_opaque) currentNumItems - 1;
	currentNumItems--;
	attrIndex += 2;

	/* see if we have overflowed XView limit */
	if (attrIndex > MAX_XVIEW_ATTRIBUTES) {
	    /* terminate and flush ATTR_LIST */
	    attrList[attrIndex] = (Xv_opaque) 0;
	    xv_set(list, ATTR_LIST, attrList, 0);
	    attrIndex = 0;
	}
    }

    /* add new entries */
    if (newNumItems != 0) {
	for (entryIndex = 0; entryIndex < newNumItems; entryIndex++) {
	    attrList[attrIndex++] = (Xv_opaque) PANEL_LIST_STRING;
	    attrList[attrIndex++] = (Xv_opaque) entryIndex;
	    if ((entries == (char **) 0) ||
			    (entries[entryIndex] == (char *) 0)) {
		/* can happen if list is empty */
		attrList[attrIndex++] = (Xv_opaque) "";
	    } else
		attrList[attrIndex++] = (Xv_opaque) entries[entryIndex];

	    /* see if we have overflowed XView limit */
	    if (attrIndex > MAX_XVIEW_ATTRIBUTES) {
		/* terminate and flush ATTR_LIST */
		attrList[attrIndex] = (Xv_opaque) 0;
		xv_set(list, ATTR_LIST, attrList,PANEL_PAINT,PANEL_NONE, 0);
		attrIndex = 0;
	    }
	}
    }
    attrList[attrIndex] = (Xv_opaque) 0;	/* terminate ATTR_LIST */

    xv_set(list, ATTR_LIST, attrList,
			PANEL_INACTIVE, (Xv_opaque) listInactive,
			0);
    /* must do this as separate call to avoid XView bug (2.0) */
    xv_set(list, PANEL_LIST_SELECT, 0, TRUE, 0);
    if (listInactive)
	xv_set(list, PANEL_LIST_SELECT, 0, FALSE, 0);

    /* zero and disable scrollbar manually (XView should do these) */
    scrollbarInactive = (listInactive ||
		(newNumItems <= (int) xv_get(list, PANEL_LIST_DISPLAY_ROWS)));
    xv_set(xv_get(list, PANEL_LIST_SCROLLBAR),
			    SCROLLBAR_VIEW_START, 0,
			    SCROLLBAR_INACTIVE, (int) scrollbarInactive,
			    0);

    free((char *) attrList);
}

void
update_cite_list()
{
	Ref             ref;
	int             i, n;
	char          **item_list;


	if (sort_flag)		/* this is now an update flag */
		return;
	get_total();
	item_list = (char **) malloc((total + 1) * sizeof(char *));
	ref = first_item;
	n = 0;
	while (ref) {
		if (ref->field[0] != NULL)
			item_list[n++] = (char *) strdup(ref->field[0]);
		ref = ref->next;
	}
	item_list[n] = (char *) 0;
	ReassignListEntries(bt_listpop->list, item_list);
	for (i = n - 1; i >= 0; i--)
		free(item_list[i]);
	free(item_list);

	return;

}

char *
  strip_space(s)
char * s;

{
    int j,i=0;
    
    while (s[i] == ' ' || s[i] == '\t')
      i++;
    
    j = strlen(s)-1;
    while (s[j] == ' ' && j>=i)
      s[j--] = '\0';
    
    return s+i;
}

void
print_item(ref)
	Ref             ref;
{
	int             i, j;
	char           *str, *tempstr;

	fprintf(infile, "\n@%s{%s", ref->ref_type, ref->field[0]);
	for (j = 1; j < 24; j++) {
		if (ref->field[j]) {
			if (strlen(ref->field[j]) > 0) {
				str = (char *) strip_space(ref->field[j]);
				if (str[0] != ABBREVCODE) {
					if (ref->open_char[j] == '\0') {
						ref->open_char[j] = FIELDLEFT;
						ref->close_char[j] = FIELDRIGHT;
					}
					if (ref->open_char[j] == ABBREVCODE) {
						fprintf(infile, ",\n   %s = %s",
						fields[j],  ref->field[j]);
					} else {
						fprintf(infile, ",\n   %s = %c%s%c",
						fields[j], ref->open_char[j], ref->field[j], ref->close_char[j]);
					}
				} else
					fprintf(infile, ",\n   %s = %s",
						fields[j], str + 1);
			}
		}
	}
	if (ref->annote) {
		if (ref->open_char[24] == '\0') {
			ref->open_char[24] = FIELDLEFT;
			ref->close_char[24] = FIELDRIGHT;
		}
		fprintf(infile, ",\n   annote = %c%s%c"
		     ,ref->open_char[24], ref->annote, ref->close_char[24]);
	}
	if (ref->nsfield) {
		tempstr = strdup(ref->nsfield);
		strtok(tempstr, "\n");
		fprintf(infile, ",\n   %s", tempstr);
		while ((str = (char *) strtok(0, "\n")) != 0)
			fprintf(infile, "\n   %s", str);
		free(tempstr);
	}
	fprintf(infile, "\n}\n");
}
SLIST
make_select_list()
{
	int             i;
	int             nItems = (int) xv_get(bt_listpop->list, PANEL_LIST_NROWS);
	SLIST           select_list,prev, new;

	select_list = 0;
	for (i = 0; i < nItems; i++) {
		if ((int) xv_get(bt_listpop->list, PANEL_LIST_SELECTED, i)) {

			if ((new = (SLIST) malloc(sizeof(SL))) == NULL) {
				fprintf(stderr, "bibcard: out of memory\n");
				exit(0);
			}
			new->selection = (char *) xv_get(bt_listpop->list, PANEL_LIST_STRING, i);
			new->next = 0;
			if (select_list == 0) {
				select_list = new;
				prev = new;
			} else {
				prev->next = new;
				prev = new;

			}
		}
	}
	return select_list;
}

void
print_selections()
{
	Ref             ref_list;
	SLIST           sel_list;

	ref_list = first_item;
	sel_list = make_select_list();
	while (sel_list) {
		while (strcmp(sel_list->selection, ref_list->field[0]) != 0) {
			ref_list = ref_list->next;
			if (ref_list == NULL)
				return;
		}
		print_item(ref_list);
		sel_list = sel_list->next;
	}
}

void
  do_title()

{
    
    char  mod[12],title[BUFSIZ];
    
    if (mod_flag) {
	strcpy(mod,"(changed)");
	xv_set(bt_window1->window1,FRAME_NO_CONFIRM, FALSE, 0);
    }
    else  {
	strcpy(mod,""); 
	xv_set(bt_window1->window1,FRAME_NO_CONFIRM, TRUE, 0);
    }
    sprintf(title,"Bib Card: %s %s",filename+strlen(pathname)+1,mod);
    xv_set(bt_window1->window1,FRAME_LABEL,title,0);
}


char *
  scan_to_alpha(s)
char * s;
{
    int i=0;
    
    while (! (isalpha(s[i]) || s[i] == '\0')) 
      i++;
    
    return s+i;
}


int count_char(s,c)
     char *s, c;
     
{
    int count=0;
    char t1[BUFSIZ], t2[BUFSIZ];
    
    strcpy(t1,s);
    while (strchr(t1,c) != 0) {
	strcpy(t2,strchr(t1,c)+1);
	strcpy(t1,t2);
	count++;
    }
    return count;
}

int count_quote(s)
     char *s;
     
{
    int i=0;
    
    while (s[i] != '\0') {
        if ((s[i-1] != '\\') && (s[i] == '"'))
	  return(1);
	i++;
    }
    return(0);
}

int
openFile(filename)
	char           *filename;

{
	char           value[BUFSIZ], errmsg[BUFSIZ], tmpfile[MAXPATHLEN];
	int             i, result;

	strcpy(value, filename);
	if (strcasecmp(value + (strlen(filename) - 4), ".bib") == 0)
		sprintf(value, "%s", filename);
	else
		sprintf(value, "%s.bib", filename);

	if (access(value, F_OK) == 0) {
		sprintf(errmsg, "file %s  already exists\n", value);

		result = notice_prompt(bt_window1->controls1, NULL,
				       NOTICE_MESSAGE_STRINGS,
				       errmsg,
				       "OK to overwrite it?", NULL,
				       NOTICE_BUTTON_YES, "OK, Make Backup",
				       NOTICE_BUTTON, "OK, No Backup", 101,
				       NOTICE_BUTTON_NO, "Cancel",
				       NULL);
		if (result == NOTICE_NO)
			return (1);
		else if (result == NOTICE_YES) {
			i = 1;
			sprintf(tmpfile, "%s.~%d~", value, i);
			while (access(tmpfile, F_OK) == 0) {
				i++;
				sprintf(tmpfile, "%s.~%d~", value, i);
			}
			sprintf(errmsg, "mv %s %s", value, tmpfile);
			system(errmsg);
		}
	}
	if ((infile = fopen(value, "w")) == NULL) {
		sprintf(errmsg, "file %s  could not be opened\n", value);

		notice_prompt(bt_window1->controls1, NULL,
			      NOTICE_MESSAGE_STRINGS,
			      errmsg, NULL,
			      NOTICE_BUTTON_YES, "Continue",
			      NULL);



		return (1);
	}
	return (0);
}

	int
	                writeFile(filename)
	char           *filename;

	{
		char           *str, value[BUFSIZ];
		int             i, j, n, result, lastcr;
		Ref             ref;

		if ((result = openFile(filename)) != 0)
			return result;
		if (SELECTION_PRINT) {
			print_selections();
			SELECTION_PRINT = FALSE;
		} else {

			if (preamble)
				if (strlen(preamble) > 0)
					fprintf(infile, "\n@preamble{%s}\n", preamble);

			i = (int) xv_get(bt_stringpop->text, TEXTSW_CONTENTS, 0,
					 value, BUFSIZ - 1);
			n = 0;
			while (i - n > 0) {
				if ((i - n) == (BUFSIZ - 1)) {	/* position counter at
								 * last cr */
					value[BUFSIZ - 1] = '\0';
					lastcr = strlen(strrchr(value, '\n')) - 1;
					value[BUFSIZ - lastcr - 1] = '\0';
					i -= lastcr;
				}
				strtok(value, "\n");
				fprintf(infile, "\n@string{%s}", value);
				while ((str = (char *) strtok(0, "\n")) != 0)
					fprintf(infile, "\n@string{%s}", str);
				n = i;
				i = (int) xv_get(bt_stringpop->text, TEXTSW_CONTENTS, n,
						 value, BUFSIZ - 1);
			}
			fprintf(infile, "\n");

			ref = first_item;
			while (ref != 0) {
				print_item(ref);
				ref = ref->next;

			}
			mod_flag = FALSE;
			do_title();
		}
		fclose(infile);
		return 0;
	}

void
show_current_item()
{
	int             i;

	hide_all();

	for (i = 0; i < 24; i++) {
		if ((*current_item).field[i]) 
			xv_set(field_ptr[i], PANEL_VALUE, (*current_item).field[i], 0);
		else
			xv_set(field_ptr[i], PANEL_VALUE, "", 0);
	}



    textsw_delete(bt_annotepop->annote_text,0,TEXTSW_INFINITY);
    textsw_reset(bt_annotepop->annote_text,0,0);
    if ((*current_item).annote)
    	textsw_insert(bt_annotepop->annote_text, (*current_item).annote,strlen((*current_item).annote));
    xv_set(bt_annotepop->annote_text,TEXTSW_FIRST, 0, NULL);
    
    
    textsw_delete(bt_nspop->ns_text,0,TEXTSW_INFINITY);
    textsw_reset(bt_nspop->ns_text,0,0);
    if ((*current_item).nsfield)
    	textsw_insert(bt_nspop->ns_text, (*current_item).nsfield,strlen((*current_item).nsfield));
    
    xv_set(bt_nspop->ns_text,TEXTSW_FIRST, 0, NULL);
    
    annote_edit_count = (int) xv_get(bt_annotepop->annote_text,TEXTSW_EDIT_COUNT);
    ns_edit_count = (int) xv_get(bt_nspop->ns_text,TEXTSW_EDIT_COUNT);
    edit_count = (int) xv_get(bt_stringpop->text,TEXTSW_EDIT_COUNT);
    
     xv_set(bt_window1->monthm,PANEL_VALUE,-1,NULL);

   
    if (strcmp(current_item->ref_type,"article") == 0) {
	xv_set(bt_window1->doc_type, PANEL_VALUE, 0, 0);	
	show_article();
    }
    else if (strcmp(current_item->ref_type,"book") == 0){
	xv_set(bt_window1->doc_type, PANEL_VALUE, 1, 0);	
	show_book();
    }
    else if (strcmp(current_item->ref_type,"booklet") == 0){
	xv_set(bt_window1->doc_type, PANEL_VALUE, 2, 0);	
	show_booklet();
    }
    else if (strcmp(current_item->ref_type,"inproceedings") == 0){
	xv_set(bt_window1->doc_type, PANEL_VALUE, 3, 0);	
	show_inproceedings();
    }
    else if (strcmp(current_item->ref_type,"inbook") == 0){
	xv_set(bt_window1->doc_type, PANEL_VALUE, 4, 0);	
	show_inbook();
    }
    else if (strcmp(current_item->ref_type,"incollection") == 0){
	xv_set(bt_window1->doc_type, PANEL_VALUE, 5, 0);	
	show_incollection();
    }
    else if (strcmp(current_item->ref_type,"manual") == 0){
	xv_set(bt_window1->doc_type, PANEL_VALUE, 6, 0);	
	show_manual();
    }
    else if (strcmp(current_item->ref_type,"mastersthesis") == 0){
	xv_set(bt_window1->doc_type, PANEL_VALUE, 7, 0);	
	show_thesis();
    }
    else if (strcmp(current_item->ref_type,"phdthesis") == 0){
	xv_set(bt_window1->doc_type, PANEL_VALUE, 8, 0);	
	show_thesis();
    }
    else if (strcmp(current_item->ref_type,"proceedings") == 0){
	xv_set(bt_window1->doc_type, PANEL_VALUE, 9, 0);	
	show_proceedings();
    }
    else if (strcmp(current_item->ref_type,"techreport") == 0){
	xv_set(bt_window1->doc_type, PANEL_VALUE, 10, 0);	
	show_techreport();
    }
    else if (strcmp(current_item->ref_type,"unpublished") == 0){
	xv_set(bt_window1->doc_type, PANEL_VALUE, 11, 0);	
	show_unpublished();
    }
    else {
	xv_set(bt_window1->doc_type, PANEL_VALUE, 12, 0);
	show_misc();
    }
    
    xv_set(bt_window1->controls1,PANEL_CARET_ITEM,bt_window1->citekey,0);
    if((int) xv_get(bt_expand->expand,XV_SHOW) == TRUE) {
    	    textsw_delete(bt_expand->ex_text,0,TEXTSW_INFINITY);
   	    textsw_reset(bt_expand->ex_text,0,0);
   	    textsw_insert(bt_expand->ex_text, 
   	        (char *)   xv_get(expand_item,PANEL_VALUE),
   	        strlen((char *) xv_get(expand_item,PANEL_VALUE)));
    	    xv_set(bt_expand->ex_text,TEXTSW_FIRST, 0, NULL);
    }
}

void
  get_path (pathname)
char pathname[];
{
    char *envpathname;
    
    if (envpathname = getenv(BIBPATHVAR))
      {
	  strncpy(pathname,envpathname,MAXPATHLEN-1);
	  pathname[MAXPATHLEN-1] = '\0';
      }
    else
      getwd(pathname);
}

int
loadFile(filename)
	char           *filename;

{
	char            temp[BUFSIZ];
	char            errmsg[BUFSIZ];
	int             i;
	extern void     new_bib();
	char	*		temp_name, *p;

	strcpy(temp, filename);
	if (strcasecmp(temp + (strlen(filename) - 4), ".bib") == 0)
		sprintf(temp, "%s", filename);
	else
		sprintf(temp, "%s.bib", filename);
	if (index(filename,':'))
		temp_name = find_in_path(pathname,temp+strlen(pathname)+1,"r");
	else
		temp_name = strdup(temp);
		
	if ((temp_name == NULL) || (infile = fopen(temp_name, "r")) == NULL) {
		sprintf(errmsg, "file %s  could not be opened", temp);

		notice_prompt(bt_window1->controls1, NULL,
			      NOTICE_MESSAGE_STRINGS,
			      errmsg, NULL,
			      NOTICE_BUTTON_YES, "Continue",
			      NULL);
		return (1);
	}
	if (!MERGE_FLAG) {
		/* first clear the abbrevation panel */

		textsw_delete(bt_stringpop->text, 0, TEXTSW_INFINITY);
		edit_count = 0;

		/* clear preamble */
		if (preamble) {
			free(preamble);
			preamble = NULL;
		}
		/* clear list */
		if (last_item != 0) {
			ref = last_item->prev;
			while (ref != 0) {
				for (i = 0; i < 24; i++)
					if (ref->field[i]) {
						free(ref->field[i]);
						ref->field[i] = NULL;
					}
				if (ref->nsfield) {
					free(ref->nsfield);
					ref->nsfield = NULL;
				}
				if (ref->annote) {
					free(ref->annote);
					ref->annote = NULL;
				}
				free(ref->next);
				ref->next = 0;
				ref = ref->prev;
			}
		}
		first_item = 0;
	} else { /*we are merging so  load at last_item (unless we are empty*/
        if (( strlen( ( char * ) xv_get(bt_window1->citekey, PANEL_VALUE)) > 0) ||  (last_item != first_item)){
        	if (PASTE_FLAG)  /* put it after the current_one */
				ref = current_item;
			else
				ref = last_item;
			prev = ref;
			}
		else
			first_item = 0;
	}

	load_bib();

	if (first_item == 0) {
		sprintf(errmsg, "file %s  contained no Bib entries", filename);

		notice_prompt(bt_window1->controls1, NULL,
			      NOTICE_MESSAGE_STRINGS,
			      errmsg, NULL,
			      NOTICE_BUTTON_YES, "Continue",
			      NULL);
		new_bib();
		return (1);
	}
	if (PASTE_FLAG) {
		if (ref->prev == last_item)
			last_item = ref;
		current_item = current_item->next;
	}
	else {
		last_item = ref;
		current_item = first_item;
	}
	fclose(infile);
	mod_flag = FALSE;
	show_current_item();

	update_cite_list();
	strcpy(filename,temp_name);
	p = rindex(temp_name,'/');
	if (p) {
		temp_name[strlen(temp_name)-strlen(p)] = '\0';
		strcpy(pathname,temp_name);
	}
	else
		strcpy(pathname,"");
	free(temp_name);
	do_title();
	return (0);

}
void
 expand(event)
	Event		*event;
{
 int	x,y,width,i;
 char  title[BUFSIZ];
 
 if (event_is_down(event) && event_action(event) == ACTION_SELECT)
  for (i = 0; i < 24 ; i++){
	width = (int) xv_get(field_ptr[i],PANEL_LABEL_WIDTH);
	x = (int) xv_get(field_ptr[i],PANEL_LABEL_X);
	y = (int) xv_get(field_ptr[i],PANEL_LABEL_Y);
	if (event_x(event) > x && event_x(event) < x + width &&
	    event_y(event) > y && event_y(event) < y + 20) {
            sprintf(title,"Expanded field: %s",(char *) xv_get(field_ptr[i], PANEL_LABEL_STRING));
            xv_set(bt_expand->expand,FRAME_LABEL,title,0);
	    xv_set(bt_expand->expand,FRAME_CMD_PUSHPIN_IN,TRUE, XV_SHOW,TRUE,0);
    	    textsw_delete(bt_expand->ex_text,0,TEXTSW_INFINITY);
   	    textsw_reset(bt_expand->ex_text,0,0);
   	    textsw_insert(bt_expand->ex_text, 
   	        (char *)   xv_get(field_ptr[i],PANEL_VALUE),
   	        strlen((char *) xv_get(field_ptr[i],PANEL_VALUE)));
    	    xv_set(bt_expand->ex_text,TEXTSW_FIRST, 0, NULL);
    	    expand_item = field_ptr[i];
       }
    }
}
	
void
sort()
{
	Ref		temp,prev;
	sort_count = oldval = 0;
	get_total();
	
	xv_set(bt_sortpop->progress,PANEL_VALUE, 0,XV_SHOW,TRUE, 0);
	panel_paint(bt_sortpop->progress,PANEL_NO_CLEAR);
	XFlush((Display *) xv_get(bt_sortpop->sortpop, XV_DISPLAY));
	temp = merge_sort(first_item);
	if (temp) {
		first_item = temp;
		first_item->prev = 0;
		temp = temp->next;
		prev = first_item;
		}
	while (temp) {
		temp->prev = prev;
		prev = temp;
		temp = temp->next;
		}
	if (prev)
	   last_item = prev;
	else
		last_item = first_item;
	current_item = first_item;
	show_current_item();
	xv_set(bt_sortpop->progress,XV_SHOW,FALSE, 0);
	update_cite_list();

}
		

void 
enter_expanded_text()

{
char  value[BUFSIZ];
int n;		 


   n = (int) xv_get(bt_expand->ex_text,TEXTSW_CONTENTS, 0, 
		     value, BUFSIZ-1);
  if (n == BUFSIZ-1) {
	value[BUFSIZ-2] = '\0';
	notice_prompt(bt_window1->controls1, NULL,
		      NOTICE_FOCUS_XY, 318, 7,
		      NOTICE_MESSAGE_STRINGS,
		      "Warning: Maximum Field Size",
		      "Text being truncated",NULL,
		      NOTICE_BUTTON_YES, "Continue",
		      NULL);
    }

  xv_set(expand_item,PANEL_VALUE,value,0);


}


void 
  next_item()

{
    if  (current_item->next == 0)
      current_item = first_item;
    else
      current_item = current_item->next;
    show_current_item();
}


void 
  prev_item()

{
    
    
    if  (current_item->prev == 0)
      current_item = last_item;
    else
      current_item = current_item->prev;
    show_current_item();
}
void
load_clip()
{
    Textsw_status status;
    
 	  xv_set(bt_clip_pop->clip_text,
		 TEXTSW_STATUS, &status,
		 TEXTSW_FILE, CLIPFILE,
		 TEXTSW_FIRST, 0,NULL);
      
}

/*************** update_clip *******************************/
/* notify routine called every second when the clip window is shown */
/* used to update the window if another bibcard has updated the clip file */

#include <sys/stat.h>

Notify_value
update_clip()
{
	struct stat     buf;
	static time_t   last_time;

	stat(CLIPFILE, &buf);
	/* if it has been changed */
	if (buf.st_mtime != last_time) {
		last_time = buf.st_mtime;
		load_clip();
	}
	return NOTIFY_DONE;
}

void
copy()
{
	char            command[200];
	int		result;

	sprintf(command, "rm -f %s", CLIPFILE);
	system(command);

		if ((result = openFile(CLIPFILE)) != 0)
			printf("could not open clip file");
	print_item(current_item);
	fclose(infile);
	if ((int) xv_get(bt_clip_pop->clip_pop,XV_SHOW))
		load_clip();
}

void
paste()
{
	PASTE_FLAG = MERGE_FLAG = TRUE;
	loadFile(CLIPFILE);
	PASTE_FLAG = MERGE_FLAG = FALSE;
}
	
void 
  add_item()

{    Ref  ref;
     
     
     if ((ref = (Reference *)malloc(sizeof(Reference))) == NULL)
       {   
	   fprintf(stderr, "bt: no memory for add");
	   exit(0);
       }
     bzero((char *) ref,sizeof(Reference));
     ref->next = current_item->next;
     ref->prev = current_item;
     strcpy(ref->ref_type,"article");    /* default new to article */
     if (current_item == last_item)
       last_item = ref;
     else
       current_item->next->prev = ref;
     current_item->next = ref;
     current_item = ref;
     show_current_item();
 }


void 
  duplicate_item()

{    Ref  ref,old;
	 int 	i;
     
     old = current_item;
     if ((ref = (Reference *)malloc(sizeof(Reference))) == NULL)
       {   
	   fprintf(stderr, "bibcard: no memory for duplicate");
	   exit(0);
       }
     bzero((char *) ref,sizeof(Reference));
     strcpy(ref->ref_type,old->ref_type);
     for (i=1 ; i < 24 ; i++) {
     	set_str(ref->field[i], old->field[i]);
     	ref->open_char[i] = old->open_char[i];
     	ref->close_char[i] = old->close_char[i];
     }
     set_str(ref->annote,old->annote);
     set_str(ref->nsfield,old->nsfield);
     ref->next = current_item->next;
     ref->prev = current_item;
     if (current_item == last_item)
       last_item = ref;
     else
       current_item->next->prev = ref;
     current_item->next = ref;
     current_item = ref;
   
     
     show_current_item();
 }


void
delete_item()
{


	if (last_item == first_item) {
		bzero((char *) current_item, sizeof(Reference));
		strcpy(current_item->ref_type,"article");  /* default new to article */
	 } else if
		(current_item == last_item) {
		last_item = current_item->prev;
		current_item->prev->next = 0;
		current_item = current_item->prev;
	} else if (current_item ==
		   first_item) {
		first_item = current_item->next;
		current_item->next->prev = 0;
		current_item = current_item->next;
	} else {
		current_item->next->prev = current_item->prev;
		current_item->prev->next = current_item->next;
		current_item =
			current_item->next;
	} 
	show_current_item();
	mod_flag = TRUE;
	update_cite_list();
	do_title();
}

void
  save_as()

{
    
    xv_set(bt_savepop->save_dir, PANEL_VALUE,strdup(pathname),0);
    if (strcmp(filename+strlen(pathname)+1,"New") == 0)
      xv_set(bt_savepop->save_file_name, PANEL_VALUE,
	     "",0);
    else
      xv_set(bt_savepop->save_file_name, PANEL_VALUE,
	     strdup(filename+strlen(pathname)+1),0);
    xv_set(bt_savepop->controls4,
	   PANEL_CARET_ITEM,bt_savepop->save_file_name,0);
	if (SELECTION_PRINT)
    	xv_set(bt_savepop->savepop,  XV_LABEL, "Save Selection As", 
    				XV_SHOW,TRUE,0);
    else
    	xv_set(bt_savepop->savepop,  XV_LABEL, "Save As",XV_SHOW,TRUE,0);
}

int
  confirm_overwrite()

{    
    int result;
    
    if ( mod_flag ) {
	result =  notice_prompt(bt_window1->controls1, NULL,
				NOTICE_MESSAGE_STRINGS,
				"You have unsaved changes. What do you want to do?",NULL,
				NOTICE_BUTTON_YES, "Save changes",
				NOTICE_BUTTON, "Discard changes", 111,
				NOTICE_BUTTON, "Cancel", 112,
				NULL);
	if (result == NOTICE_YES) 
	  if (strcmp(filename+strlen(pathname)+1,"New") == 0){
	      save_as();
	      return(1);
	  }
	  else
	    return(writeFile(filename));
	else if (result == 111)
	  return(0);
	else
	  return(1);
    }
    else
      return(0);
}


void
  save_button()

{
    xv_set(bt_savepop->savepop, FRAME_BUSY, TRUE,XV_NULL);
	if (strlen((char *) xv_get(bt_savepop->save_dir, PANEL_VALUE)) > 0)
    	sprintf(filename,"%s/%s",
	    (char *) xv_get(bt_savepop->save_dir, PANEL_VALUE),
	    (char *) xv_get(bt_savepop->save_file_name, PANEL_VALUE));
	   else
    	sprintf(filename,"%s",
	    (char *) xv_get(bt_savepop->save_file_name, PANEL_VALUE));
    
    if (writeFile(filename) == 1)
      xv_set(bt_savepop->savepop, FRAME_CMD_PUSHPIN_IN,TRUE,0);
    else
      xv_set(bt_savepop->savepop, FRAME_CMD_PUSHPIN_IN,FALSE, XV_SHOW,FALSE,0);
    xv_set(bt_savepop->savepop, FRAME_BUSY, FALSE,XV_NULL);
}		

void
  load_button()

{	char * tmp;
	xv_set(bt_loadpop->loadpop, FRAME_BUSY, TRUE,XV_NULL);
	tmp = (char *) xv_get(bt_loadpop->load_dir, PANEL_VALUE);
	strcpy(pathname,tmp);
	sprintf(filename,"%s/%s",
		tmp,
		(char *) xv_get(bt_loadpop->load_file, PANEL_VALUE));
	
	if (loadFile(filename) == 1)
	  xv_set(bt_loadpop->loadpop, FRAME_CMD_PUSHPIN_IN,TRUE,0);
	else {
	    xv_set(bt_loadpop->loadpop, FRAME_CMD_PUSHPIN_IN,FALSE,0);
	    xv_set(bt_loadpop->loadpop, XV_SHOW,FALSE,0);
	}
	xv_set(bt_loadpop->loadpop, FRAME_BUSY, FALSE,XV_NULL);
    }

/*
 * Notify callback function for `monthm'.
 */
void
  month_menu(item, value, event)
Panel_item	item;
int		value;
Event		*event;
{	

    xv_set(bt_window1->month,PANEL_VALUE,
	   months[(int) xv_get(bt_window1->monthm,PANEL_VALUE)],
	   0);
    
}

int
update_item()
{
	int             i, n, nextn;
	char            value[BUFSIZ];


	for (i = 1; i < 24; i++) {
		strcpy(value, (char *) xv_get(field_ptr[i], PANEL_VALUE));
		if ((current_item->field[i] == NULL) && (strlen(value) > 0)) {
			set_str(current_item->field[i], value);
			mod_flag = TRUE;
		} else if (current_item->field[i]) {
			if (strcmp(current_item->field[i], value) != 0) {
				set_str(current_item->field[i], value);
				mod_flag = TRUE;
			}
		}
	}
	
	
	/* Do annote update based on edit count; */
	if (annote_edit_count < (int) xv_get(bt_annotepop->annote_text, TEXTSW_EDIT_COUNT)) {

		annote_edit_count = (int) xv_get(bt_annotepop->annote_text, TEXTSW_EDIT_COUNT);
		mod_flag = TRUE;
		nextn = 0;
		n = (int) xv_get(bt_annotepop->annote_text, TEXTSW_CONTENTS, 0,
				 value, BUFSIZ - 1);
		if (n > 0) {
			if (n == (BUFSIZ - 1))
				value[BUFSIZ - 1] = '\0';
			set_str(current_item->annote, value);

			while (((n - nextn) > 0) || (n == (BUFSIZ - 1))) {
				nextn = n;
				n = (int) xv_get(bt_annotepop->annote_text, TEXTSW_CONTENTS, nextn,
						 value, BUFSIZ - 1);
				if ((n - nextn) == (BUFSIZ - 1))
					value[BUFSIZ - 1] = '\0';
				add_to(current_item->annote, value);
			}
		}
	}

	/* Do non-standard field update based on edit count */
	if (ns_edit_count < (int) xv_get(bt_nspop->ns_text, TEXTSW_EDIT_COUNT)) {

		ns_edit_count = (int) xv_get(bt_nspop->ns_text, TEXTSW_EDIT_COUNT);
		mod_flag = TRUE;
	nextn = 0;
	n = (int) xv_get(bt_nspop->ns_text, TEXTSW_CONTENTS, 0,
			 value, BUFSIZ - 1);
	if (n > 0) {
		if (n == (BUFSIZ - 1))
			value[BUFSIZ - 1] = '\0';
		set_str(current_item->nsfield, value);

		while (((n - nextn) > 0) || (n == (BUFSIZ - 1))) {
			nextn = n;
			n = (int) xv_get(bt_nspop->ns_text, TEXTSW_CONTENTS, nextn,
					 value, BUFSIZ - 1);
			add_to(current_item->nsfield, value);
		}
	}
	}
	n = (int) xv_get(bt_window1->doc_type, PANEL_VALUE);

	if (strcmp(current_item->ref_type, rtypes[n]) != 0) {
		strcpy(current_item->ref_type, rtypes[n]);
		mod_flag = TRUE;
	}
	strcpy(value, (char *) xv_get(bt_window1->citekey, PANEL_VALUE));
	if (strlen(value) < 1) {
		notice_prompt(bt_window1->controls1, NULL,
			      NOTICE_FOCUS_XY, 318, 7,
			      NOTICE_MESSAGE_STRINGS,
			      "Empty Cite Key", NULL,
			      NOTICE_BUTTON_YES, "Continue",
			      NULL);
		return (1);
	}
	if (!(current_item->field[0]) ? TRUE : strcmp(current_item->field[0], value) != 0) {
		mod_flag = TRUE;
		if (!(current_item->field[0]) ? TRUE : strcasecmp(current_item->field[0], value) != 0) {	/* don't check if it is
														 * a */
			if (duplicate_cite_key(value)) {	/* case change */
				notice_prompt(bt_window1->controls1, NULL,
					      NOTICE_FOCUS_XY, 318, 7,
					      NOTICE_MESSAGE_STRINGS,
					      "Duplicate Cite Key", NULL,
					      NOTICE_BUTTON_YES, "Continue",
					      NULL);
				return (1);
			}
		}
		set_str(current_item->field[0], value);


		update_cite_list();
	}
	/* check strings for modifications */
	if (edit_count < (int) xv_get(bt_stringpop->text, TEXTSW_EDIT_COUNT)) {

		edit_count = (int) xv_get(bt_stringpop->text, TEXTSW_EDIT_COUNT);
		mod_flag = TRUE;
	}
	do_title();
	return (0);
}


void
  show_cite(key)
char * key;

{
    Ref ref;
    
    ref = first_item;
    
    while (ref != 0) {
    if (ref->field[0])
	if (strcmp(key,ref->field[0]) == 0) {
	    current_item = ref;
	    show_current_item();
	    break;
	}	      
	ref = ref->next;
    }
}

void
next_field(item, offset)
	Panel_item      item;
	int             offset;

{
	int             i;
	if (offset > 0) {
		if (strcmp((char *) xv_get(item, PANEL_LABEL_STRING),
			   "Cross ref key:") == 0) {
			xv_set(bt_window1->controls1,
			       PANEL_CARET_ITEM, nxt_fld[0], 0);
			return;
		}
	}
	if (offset < 0) {
		if (strcmp((char *) xv_get(item, PANEL_LABEL_STRING),
			   "Cite Key:") == 0) {
			xv_set(bt_window1->controls1,
			       PANEL_CARET_ITEM, nxt_fld[last_field], 0);
			return;
		}
	}
	for (i = 0; i < last_field; i++)
		if (item == nxt_fld[i]) {
			xv_set(bt_window1->controls1,
			       PANEL_CARET_ITEM, nxt_fld[i + offset], 0);
			break;

		}
}

void
  new_bib() 

{
    int  i,n;
    Ref ref;
    
    /* clear list */
    if (last_item != 0) {
	ref = last_item->prev;
	while (ref != 0) {
	    free(ref->next);
	    ref->next = 0;
	    ref = ref->prev;
	}
    }
    
    if ((ref = (Ref) malloc(sizeof(Reference))) == NULL)
      {   
	  fprintf(stderr, "bibcard: no memory for load\n");
	  exit(0); 
      }
    bzero((char *) ref,sizeof(Reference));
    
    first_item = current_item = last_item = ref;
    strcpy(ref->ref_type,"article");    /* default new to article */
    ref->next = 0;
    ref->prev = 0;
    show_current_item();
    
    /*    clear the abbrevation panel */
    
    textsw_delete(bt_stringpop->text,0,TEXTSW_INFINITY);
    
    /* clear cite list */
    n = (int) xv_get(bt_listpop->list,PANEL_LIST_NROWS);
    if (n > 0)
      for (i = n-1; i >= 0 ; i--)
	xv_set(bt_listpop->list,PANEL_LIST_DELETE, i, 0);
    mod_flag = FALSE;
    get_path(pathname);
    sprintf(filename,"%s/%s",pathname,"New");
    
    do_title();
}



/*
  booklet
  */

show_booklet()
     
{      inum = 2;
       nxt_fld[inum++] = bt_window1->title;
       
       xv_set(bt_window1->title,    
	      PANEL_VALUE_X, 64,
	      PANEL_VALUE_Y, 80,
	      XV_SHOW, TRUE,
	      0);
       
       xv_set(bt_window1->message1, 
	      XV_X, 8,
	      XV_Y, 112,
	      XV_SHOW, TRUE,
	      0);
       
       nxt_fld[inum++] = bt_window1->howpublished;
       xv_set(bt_window1->howpublished, 
	      XV_X, 10,
	      XV_Y, 144,
	      XV_SHOW, TRUE,
	      0);
	      
       nxt_fld[inum++] = bt_window1->author;
       xv_set(bt_window1->author,   
	      XV_X, 32,
	      XV_Y, 174,
	      XV_SHOW, TRUE,
	      0);
       
       
       nxt_fld[inum++] = bt_window1->year;
       
       xv_set(bt_window1->year, 
	      XV_X, 64,
	      XV_Y, 204,
	      XV_SHOW, TRUE,
	      0);
       
       nxt_fld[inum++] = bt_window1->address;
       xv_set(bt_window1->address,  
	      XV_X, 40,
	      XV_Y, 234,
	      XV_SHOW, TRUE,
	      0);
       
       xv_set(bt_window1->monthm,    
	      XV_X, 54,
	      XV_Y, 259,
	      XV_SHOW, TRUE,
	      0);
       
       nxt_fld[inum++] = bt_window1->month;
       xv_set(bt_window1->month,    
	      XV_X, 131,
	      XV_Y, 264,
	      XV_SHOW, TRUE,
	      0);
       
       
       nxt_fld[inum++] = bt_window1->edition;
       xv_set(bt_window1->edition,  
	      XV_X, 47,
	      XV_Y, 294,
	      XV_SHOW, TRUE,
	      0);
       
       nxt_fld[inum++] = bt_window1->note;
       xv_set(bt_window1->note, 
	      XV_X, 64,
	      XV_Y, 352,
	      XV_SHOW, TRUE,
	      0);
       
       nxt_fld[inum++] = bt_window1->crossref;
       xv_set(bt_window1->crossref, 
	      XV_X, 8,
	      XV_Y, 384,
	      XV_SHOW, TRUE,
	      0);
       last_field = inum-1;
   }
/*
  article
  */

show_article()
     
{      inum = 2;
       nxt_fld[inum++] = bt_window1->author;
       xv_set(bt_window1->author,
	      XV_X, 31,
	      XV_Y, 80,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->title;
       xv_set(bt_window1->title,    
	      XV_X, 63,
	      XV_Y, 104,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->journal;
       xv_set(bt_window1->journal,    
	      XV_X, 44,
	      XV_Y, 132,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->year;
       xv_set(bt_window1->year,    
	      XV_X, 64,
	      XV_Y, 164,
	      XV_SHOW, TRUE,
	      0);
       xv_set(bt_window1->message1,    
	      XV_X, 8,
	      XV_Y, 196,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->pages;
       xv_set(bt_window1->pages,    
	      XV_X, 55,
	      XV_Y, 220,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->volume;
       xv_set(bt_window1->volume,    
	      XV_X, 43,
	      XV_Y, 252,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->number;
       xv_set(bt_window1->number,    
	      XV_X, 39,
	      XV_Y, 284,
	      XV_SHOW, TRUE,
	      0);
       
       xv_set(bt_window1->monthm,    
	      XV_X, 51,
	      XV_Y, 316,
	      XV_SHOW, TRUE,
	      0);
       
       nxt_fld[inum++] = bt_window1->month;
       xv_set(bt_window1->month,    
	      XV_X, 128,
	      XV_Y, 322,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->note;
       xv_set(bt_window1->note,    
	      XV_X, 52,
	      XV_Y, 348,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->crossref;
       xv_set(bt_window1->crossref, 
	      XV_X, 31,
	      XV_Y, 384,
	      XV_SHOW, TRUE,
	      0);
       last_field = inum-1;
   }

hide_all()
     
{    int  i;
     
     for ( i=1; i<24; i++)
       if ( i != 11)
	 xv_set(field_ptr[i],XV_X, 8,XV_Y, 422,XV_SHOW,FALSE,0);
     
     xv_set(bt_window1->message1,    
	    XV_X, 8,
	    XV_Y, 422,
	    XV_SHOW, FALSE,
	    0);
     xv_set(bt_window1->monthm,    
	    XV_X, 8,
	    XV_Y, 422,
	    XV_SHOW, FALSE,
	    0);
 }
/*
  book
  */

show_book()
     
{      inum = 2;
       nxt_fld[inum++] = bt_window1->author;
       xv_set(bt_window1->author,    
	      XV_X, 32,
	      XV_Y, 72,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->editor;
       xv_set(bt_window1->editor,    
	      XV_X, 37,
	      XV_Y, 98,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->title;
       xv_set(bt_window1->title,    
	      XV_X, 64,
	      XV_Y, 124,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->publisher;
       xv_set(bt_window1->publisher,    
	      XV_X, 32,
	      XV_Y, 150,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->year;
       xv_set(bt_window1->year,    
	      XV_X, 64,
	      XV_Y, 176,
	      XV_SHOW, TRUE,
	      0);
       xv_set(bt_window1->message1,    
	      XV_X, 8,
	      XV_Y, 202,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->address;
       xv_set(bt_window1->address,    
	      XV_X, 40,
	      XV_Y, 228,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->volume;
       xv_set(bt_window1->volume,    
	      XV_X, 48,
	      XV_Y, 254,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->number;
       xv_set(bt_window1->number,    
	      XV_X, 240,
	      XV_Y, 254,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->series;
       xv_set(bt_window1->series,    
	      XV_X, 56,
	      XV_Y, 280,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->edition;
       xv_set(bt_window1->edition,    
	      XV_X, 48,
	      XV_Y, 306,
	      XV_SHOW, TRUE,
	      0);
       
       xv_set(bt_window1->monthm,    
	      XV_X, 56,
	      XV_Y, 327,
	      XV_SHOW, TRUE,
	      0);
       
       nxt_fld[inum++] = bt_window1->month;
       xv_set(bt_window1->month,    
	      XV_X, 128,
	      XV_Y, 332,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->note;
       xv_set(bt_window1->note,    
	      XV_X, 64,
	      XV_Y, 361,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->crossref;
       xv_set(bt_window1->crossref,    
	      XV_X, 8,
	      XV_Y, 392,
	      XV_SHOW, TRUE,
	      0);
       last_field = inum-1;
   }

show_inbook()
     
{      inum = 2;
       nxt_fld[inum++] = bt_window1->author;
       xv_set(bt_window1->author,    
	      XV_X, 32,
	      XV_Y, 80,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->title;
       xv_set(bt_window1->title,    
	      XV_X, 64,
	      XV_Y, 104,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->pages;
       xv_set(bt_window1->pages,    
	      XV_X, 56,
	      XV_Y, 128,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->chapter;
       xv_set(bt_window1->chapter,    
	      XV_X, 224,
	      XV_Y, 128,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->publisher;
       xv_set(bt_window1->publisher,    
	      XV_X, 29,
	      XV_Y, 152,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->year;
       xv_set(bt_window1->year,    
	      XV_X, 64,
	      XV_Y, 176,
	      XV_SHOW, TRUE,
	      0);
       xv_set(bt_window1->message1,    
	      XV_X, 0,
	      XV_Y, 200,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->volume;
       xv_set(bt_window1->volume,    
	      XV_X, 48,
	      XV_Y, 224,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->series;
       xv_set(bt_window1->series,    
	      XV_X, 224,
	      XV_Y, 224,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->address;
       xv_set(bt_window1->address,    
	      XV_X, 40,
	      XV_Y, 248,
	      XV_SHOW, TRUE,
	      0);
       
       xv_set(bt_window1->monthm,    
	      XV_X, 56,
	      XV_Y, 266,
	      XV_SHOW, TRUE,
	      0);
       
       nxt_fld[inum++] = bt_window1->month;
       xv_set(bt_window1->month,    
	      XV_X, 128,
	      XV_Y, 272,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->edition;
       xv_set(bt_window1->edition,    
	      XV_X, 48,
	      XV_Y, 296,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->number;
       xv_set(bt_window1->number,    
	      XV_X, 224,
	      XV_Y, 296,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->editor;
       xv_set(bt_window1->editor,    
	      XV_X, 40,
	      XV_Y, 320,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->type;
       xv_set(bt_window1->type,    
	      XV_X, 2,
	      XV_Y, 344,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->note;
       xv_set(bt_window1->note,    
	      XV_X, 64,
	      XV_Y, 368,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->crossref;
       xv_set(bt_window1->crossref,    
	      XV_X, 8,
	      XV_Y, 392,
	      XV_SHOW, TRUE,
	      0);
       last_field = inum-1;
   }

show_incollection()
     
{      inum = 2;
       nxt_fld[inum++] = bt_window1->author;
       xv_set(bt_window1->author,    
	      XV_X, 31,
	      XV_Y, 80,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->title;
       xv_set(bt_window1->title,    
	      XV_X, 64,
	      XV_Y, 104,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->booktitle;
       xv_set(bt_window1->booktitle,    
	      XV_X, 26,
	      XV_Y, 128,
	      XV_SHOW, TRUE,
	      0);
       
       nxt_fld[inum++] = bt_window1->publisher;
       xv_set(bt_window1->publisher,    
	      XV_X, 28,
	      XV_Y, 152,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->year;
       xv_set(bt_window1->year,    
	      XV_X, 64,
	      XV_Y, 176,
	      XV_SHOW, TRUE,
	      0);
       xv_set(bt_window1->message1,    
	      XV_X, 0,
	      XV_Y, 200,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->editor;
       xv_set(bt_window1->editor,    
	      XV_X, 37,
	      XV_Y, 224,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->volume;
       xv_set(bt_window1->volume,    
	      XV_X, 43,
	      XV_Y, 248,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->number;
       xv_set(bt_window1->number,    
	      XV_X, 283,
	      XV_Y, 249,
	      XV_SHOW, TRUE,
	      0);
       
       xv_set(bt_window1->monthm,    
	      XV_X, 448,
	      XV_Y, 248,
	      XV_SHOW, TRUE,
	      0);
       
       nxt_fld[inum++] = bt_window1->month;
       xv_set(bt_window1->month,    
	      XV_X, 525,
	      XV_Y, 254,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->pages;
       xv_set(bt_window1->pages,    
	      XV_X, 55,
	      XV_Y, 272,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->chapter;
       xv_set(bt_window1->chapter,    
	      XV_X, 227,
	      XV_Y, 272,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->edition;
       xv_set(bt_window1->edition,    
	      XV_X, 448,
	      XV_Y, 272,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->series;
       xv_set(bt_window1->series,    
	      XV_X, 52,
	      XV_Y, 296,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->address;
       xv_set(bt_window1->address,    
	      XV_X, 40,
	      XV_Y, 320,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->type;
       xv_set(bt_window1->type,    
	      XV_X, 2,
	      XV_Y, 344,
	      
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->note;
       xv_set(bt_window1->note,    
	      XV_X, 64,
	      XV_Y, 376,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->crossref;
       xv_set(bt_window1->crossref,    
	      XV_X, 4,
	      XV_Y, 400,
	      XV_SHOW, TRUE,
	      0);
       last_field = inum-1;
   }

show_inproceedings()
     
{      inum = 2;
       nxt_fld[inum++] = bt_window1->author;
       xv_set(bt_window1->author,    
	      XV_X, 41,
	      XV_Y, 63,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->title;
       xv_set(bt_window1->title,    
	      XV_X, 73,
	      XV_Y, 87,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->booktitle;
       xv_set(bt_window1->booktitle,    
	      XV_X, 33,
	      XV_Y, 111,
	      XV_SHOW, TRUE,
	      0);
       
       nxt_fld[inum++] = bt_window1->year;
       xv_set(bt_window1->year,    
	      XV_X, 73,
	      XV_Y, 135,
	      XV_SHOW, TRUE,
	      0);
       xv_set(bt_window1->message1,    
	      XV_X, 0,
	      XV_Y, 160,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->editor;
       xv_set(bt_window1->editor,    
	      XV_X, 46,
	      XV_Y, 183,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->volume;
       xv_set(bt_window1->volume,    
	      XV_X, 52,
	      XV_Y, 207,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->number;
       xv_set(bt_window1->number,    
	      XV_X, 216,
	      XV_Y, 208,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->pages;
       xv_set(bt_window1->pages,    
	      XV_X, 388,
	      XV_Y, 208,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->series;
       xv_set(bt_window1->series,    
	      XV_X, 61,
	      XV_Y, 231,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->publisher;
       xv_set(bt_window1->publisher,    
	      XV_X, 37,
	      XV_Y, 263,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->address;
       xv_set(bt_window1->address,    
	      XV_X, 49,
	      XV_Y, 295,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->organization;
       xv_set(bt_window1->organization,    
	      XV_X, 15,
	      XV_Y, 319,
	      XV_SHOW, TRUE,
	      0);
       xv_set(bt_window1->monthm,    
	      XV_X, 61,
	      XV_Y, 343,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->month;
       xv_set(bt_window1->month,    
	      XV_X, 138,
	      XV_Y, 349,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->note;
       xv_set(bt_window1->note,    
	      XV_X, 73,
	      XV_Y, 367,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->crossref;
       xv_set(bt_window1->crossref,    
	      XV_X, 17,
	      XV_Y, 391,
	      XV_SHOW, TRUE,
	      0);
       last_field = inum-1;
   }

show_proceedings()
     
{      inum = 2;
       nxt_fld[inum++] = bt_window1->title;
       xv_set(bt_window1->title,    
	      XV_X, 73,
	      XV_Y, 87,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->year;
       xv_set(bt_window1->year,    
	      XV_X, 73,
	      XV_Y, 112,
	      XV_SHOW, TRUE,
	      0);
       xv_set(bt_window1->message1,    
	      XV_X, 0,
	      XV_Y, 152,
	      XV_SHOW, TRUE,
	      0);

       nxt_fld[inum++] = bt_window1->editor;
       xv_set(bt_window1->editor,    
	      XV_X, 48,
	      XV_Y, 184,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->volume;
       xv_set(bt_window1->volume,    
	      XV_X, 52,
	      XV_Y, 207,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->number;
       xv_set(bt_window1->number,    
	      XV_X, 216,
	      XV_Y, 208,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->series;
       xv_set(bt_window1->series,    
	      XV_X, 61,
	      XV_Y, 231,
	      XV_SHOW, TRUE,
	      0);
        nxt_fld[inum++] = bt_window1->publisher;
       xv_set(bt_window1->publisher,    
	      XV_X, 37,
	      XV_Y, 263,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->address;
       xv_set(bt_window1->address,    
	      XV_X, 49,
	      XV_Y, 295,
	      XV_SHOW, TRUE,
	      0);

       nxt_fld[inum++] = bt_window1->organization;
       xv_set(bt_window1->organization,    
	      XV_X, 15,
	      XV_Y, 319,
	      XV_SHOW, TRUE,
	      0);
      xv_set(bt_window1->monthm,    
	      XV_X, 61,
	      XV_Y, 343,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->month,
       xv_set(bt_window1->month,    
	      XV_X, 138,
	      XV_Y, 349,
	      XV_SHOW, TRUE,
	      0);
	      
       nxt_fld[inum++] = bt_window1->note;
       xv_set(bt_window1->note,    
	      XV_X, 73,
	      XV_Y, 367,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->crossref;
       xv_set(bt_window1->crossref,    
	      XV_X, 17,
	      XV_Y, 391,
	      XV_SHOW, TRUE,
	      0);
       last_field = inum-1;
   }


show_manual()
     
{      inum = 2;
       nxt_fld[inum++] = bt_window1->title;
       xv_set(bt_window1->title,    
	      XV_X, 64,
	      XV_Y, 80,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->year;
       xv_set(bt_window1->year,    
	      XV_X, 64,
	      XV_Y, 144,
	      XV_SHOW, TRUE,
	      0);
       
       xv_set(bt_window1->message1,    
	      XV_X, 2,
	      XV_Y, 112,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->author;
       xv_set(bt_window1->author,    
	      XV_X, 32,
	      XV_Y, 168,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->organization;
       xv_set(bt_window1->organization,    
	      XV_X, 9,
	      XV_Y, 192,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->address;
       xv_set(bt_window1->address,    
	      XV_X, 41,
	      XV_Y, 216,
	      XV_SHOW, TRUE,
	      0);
       xv_set(bt_window1->monthm,    
	      XV_X, 56,
	      XV_Y, 240,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->month,
       xv_set(bt_window1->month,    
	      XV_X, 133,
	      XV_Y, 246,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->edition,
       xv_set(bt_window1->edition,    
	      XV_X, 48,
	      XV_Y, 270,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->note;
       xv_set(bt_window1->note,    
	      XV_X, 64,
	      XV_Y, 352,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->crossref;
       xv_set(bt_window1->crossref,    
	      XV_X, 8,
	      XV_Y, 384,
	      XV_SHOW, TRUE,
	      0);
       last_field = inum-1;
   }

show_thesis()
     
{      inum = 2;
       nxt_fld[inum++] = bt_window1->author;
       xv_set(bt_window1->author,    
	      XV_X, 40,
	      XV_Y, 80,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->title;
       xv_set(bt_window1->title,    
	      XV_X, 72,
	      XV_Y, 112,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->school;
       xv_set(bt_window1->school,    
	      XV_X, 59,
	      XV_Y, 144,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->year;
       xv_set(bt_window1->year,    
	      XV_X, 73,
	      XV_Y, 176,
	      XV_SHOW, TRUE,
	      0);
       
       xv_set(bt_window1->message1,    
	      XV_X, 0,
	      XV_Y, 208,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->type;
       xv_set(bt_window1->type,    
	      XV_X, 6,
	      XV_Y, 240,
	      XV_SHOW, TRUE,
	      0);
       
       nxt_fld[inum++] = bt_window1->address;
       xv_set(bt_window1->address,    
	      XV_X, 49,
	      XV_Y, 272,
	      XV_SHOW, TRUE,
	      0);
       xv_set(bt_window1->monthm,    
	      XV_X, 61,
	      XV_Y, 304,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->month;
       xv_set(bt_window1->month,    
	      XV_X, 138,
	      XV_Y, 310,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->note;
       xv_set(bt_window1->note,    
	      XV_X, 73,
	      XV_Y, 360,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->crossref;
       xv_set(bt_window1->crossref,    
	      XV_X, 13,
	      XV_Y, 392,
	      XV_SHOW, TRUE,
	      0);
       last_field = inum-1;
   }


show_techreport()
     
{      inum = 2;
       nxt_fld[inum++] = bt_window1->author;
       xv_set(bt_window1->author,    
	      XV_X, 32,
	      XV_Y, 88,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->title;
       xv_set(bt_window1->title,    
	      XV_X, 64,
	      XV_Y, 112,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->institution;
       xv_set(bt_window1->institution,    
	      XV_X, 24,
	      XV_Y, 136,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->year;
       xv_set(bt_window1->year,    
	      XV_X, 72,
	      XV_Y, 160,
	      XV_SHOW, TRUE,
	      0);
       xv_set(bt_window1->message1,    
	      XV_X, 8,
	      XV_Y, 216,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->address;
       xv_set(bt_window1->address,    
	      XV_X, 48,
	      XV_Y, 248,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->number;
       xv_set(bt_window1->number,    
	      XV_X, 48,
	      XV_Y, 272,
	      XV_SHOW, TRUE,
	      0);
       
       xv_set(bt_window1->monthm,    
	      XV_X, 56,
	      XV_Y, 296,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->month;
       xv_set(bt_window1->month,    
	      XV_X, 133,
	      XV_Y, 301,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->type;
       xv_set(bt_window1->type,    
	      XV_X, 16,
	      XV_Y, 331,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->note;
       xv_set(bt_window1->note,    
	      XV_X, 72,
	      XV_Y, 368,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->crossref;
       xv_set(bt_window1->crossref,    
	      XV_X, 8,
	      XV_Y, 392,
	      XV_SHOW, TRUE,
	      0);
       last_field = inum-1;
   }

show_unpublished()
     
{      inum = 2;
       nxt_fld[inum++] = bt_window1->author;
       xv_set(bt_window1->author,    
	      XV_X, 27,
	      XV_Y, 88,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->title;
       xv_set(bt_window1->title,    
	      XV_X, 56,
	      XV_Y, 120,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->note;
       xv_set(bt_window1->note,    
	      XV_X, 56,
	      XV_Y, 152,
	      XV_SHOW, TRUE,
	      0);
       
       xv_set(bt_window1->message1,    
	      XV_X, 8,
	      XV_Y, 216,
	      XV_SHOW, TRUE,
	      0);
       
       xv_set(bt_window1->monthm,    
	      XV_X, 48,
	      XV_Y, 240,
	      XV_SHOW, TRUE,
	      0);
       
       nxt_fld[inum++] = bt_window1->month;
       xv_set(bt_window1->month,    
	      XV_X, 125,
	      XV_Y, 246,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->year;
       xv_set(bt_window1->year,    
	      XV_X, 60,
	      XV_Y, 284,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->crossref;
       xv_set(bt_window1->crossref,    
	      XV_X, 8,
	      XV_Y, 392,
	      XV_SHOW, TRUE,
	      0);
       last_field = inum-1;
   }

show_misc()
     
{      inum = 2;
       nxt_fld[inum++] = bt_window1->author;
       xv_set(bt_window1->author,    
	      XV_X, 31,
	      XV_Y, 125,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->title;
       xv_set(bt_window1->title,    
	      XV_X, 63,
	      XV_Y, 157,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->howpublished;
       xv_set(bt_window1->howpublished,    
	      XV_X, 2,
	      XV_Y, 189,
	      XV_SHOW, TRUE,
	      0);
       xv_set(bt_window1->message1,    
	      XV_X, 2,
	      XV_Y, 88,
	      XV_SHOW, TRUE,
	      0);
       
       xv_set(bt_window1->monthm,    
	      XV_X, 47,
	      XV_Y, 221,
	      XV_SHOW, TRUE,
	      0);
       
       nxt_fld[inum++] = bt_window1->month;
       xv_set(bt_window1->month,    
	      XV_X, 124,
	      XV_Y, 227,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->year;
       xv_set(bt_window1->year,    
	      XV_X, 63,
	      XV_Y, 253,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->note;
       xv_set(bt_window1->note,    
	      XV_X, 63,
	      XV_Y, 285,
	      XV_SHOW, TRUE,
	      0);
       nxt_fld[inum++] = bt_window1->crossref;
       xv_set(bt_window1->crossref,    
	      XV_X, 2,
	      XV_Y, 392,
	      XV_SHOW, TRUE,
	      0);
       last_field = inum-1;
   }


